Bug 1020468 - Review Request: ucpp - Embeddable, quick, light and fully compliant ISO C99 preprocessor
Review Request: ucpp - Embeddable, quick, light and fully compliant ISO C99 p...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Christopher Meng
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-17 13:55 EDT by Dominik 'Rathann' Mierzejewski
Modified: 2014-03-07 01:38 EST (History)
4 users (show)

See Also:
Fixed In Version: ucpp-1.3.4-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-07 01:33:44 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
i: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Dominik 'Rathann' Mierzejewski 2013-10-17 13:55:51 EDT
Spec URL: http://rathann.fedorapeople.org/review/ucpp/ucpp.spec
SRPM URL: http://rathann.fedorapeople.org/review/ucpp/ucpp-1.3.2-1.fc19.src.rpm
Description: 
A C preprocessor is a part of a C compiler responsible for macro replacement,
conditional compilation and inclusion of header files. It is often found as
a stand-alone program on Unix systems.

ucpp is such a preprocessor; it is designed to be quick and light, but anyway
fully compliant to the ISO standard 9899:1999, also known as C99. ucpp can be
compiled as a stand-alone program, or linked to some other code; in the latter
case, ucpp will output tokens, one at a time, on demand, as an integrated lexer.

Fedora Account System Username: rathann
Comment 1 Christopher Meng 2013-10-17 23:28:42 EDT
gentoo ebuild shows that 1.3.4 is the latest version:

http://dev.gentooexperimental.org/~scarabeus/ucpp-1.3.4.tar.xz

Can you verify it?
Comment 2 Dominik 'Rathann' Mierzejewski 2013-10-20 18:46:34 EDT
Looks like a fork based on upstream 1.3.2 version. However, there have been no new releases from original upstream, so we might just as well consider the fork as the new upstream: https://github.com/scarabeusiv/ucpp

I'll prepare an updated package based on that, once I verify that the application for which ucpp is a dependency still builds and works. Thanks for pointing it out.
Comment 3 Dominik 'Rathann' Mierzejewski 2013-10-30 18:16:34 EDT
Updated package:

Spec URL: http://rathann.fedorapeople.org/review/ucpp/ucpp.spec
SRPM URL: http://rathann.fedorapeople.org/review/ucpp/ucpp-1.3.4-1.fc19.src.rpm
Comment 4 Ralf Corsepius 2013-10-31 04:51:35 EDT
Make is silent - It's impossible to check whether this package is compiled correctly from build.logs
=> Please append --disable-silent-rules to %configure


rpmlint complains:
...
ucpp-libs.x86_64: W: file-not-utf8 /usr/share/doc/ucpp-libs/README
ucpp-libs.x86_64: E: library-without-ldconfig-postin /usr/lib64/libucpp.so.13.0.4
ucpp-libs.x86_64: E: library-without-ldconfig-postun /usr/lib64/libucpp.so.13.0.4
Comment 5 Dominik 'Rathann' Mierzejewski 2013-11-03 01:21:30 EST
Fixed all issues:

Spec URL: http://rathann.fedorapeople.org/review/ucpp/ucpp.spec
SRPM URL: http://rathann.fedorapeople.org/review/ucpp/ucpp-1.3.4-2.fc19.src.rpm
Comment 6 Christopher Meng 2014-01-23 22:37:46 EST
1. Please modify with ?_isa appended:

Requires: %{name}-libs{?_isa} = %{version}-%{release}

2. Please improve devel and libs' %package and %description, both not good IMO.

An example:

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description    devel
This package contains libraries and header files for
developing applications that use %{name}.

-------

%package        libs
Summary:        Shared libraries for %{name}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description    devel
This package contains shared libraries for %{name}.
Comment 7 Christopher Meng 2014-01-23 22:39:37 EST
Oops, ignore the copy-paste wrong 

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}


in the -libs. ;)
Comment 8 Dominik 'Rathann' Mierzejewski 2014-02-21 20:30:41 EST
Added ?_isa to dependencies.
What's wrong with the descriptions? Can you suggest improvements?

Spec URL: http://rathann.fedorapeople.org/review/ucpp/ucpp.spec
SRPM URL: http://rathann.fedorapeople.org/review/ucpp/ucpp-1.3.4-3.fc20.src.rpm
Comment 9 Christopher Meng 2014-02-23 11:55:24 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated




===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 19 files have unknown
     license. Detailed output of licensecheck:

GPL (v2 or later)
-----------------
ucpp-1.3.4/ltmain.sh

Unknown or generated
--------------------
ucpp-1.3.4/src/arith.c
ucpp-1.3.4/src/arith.h
ucpp-1.3.4/src/assert.c
ucpp-1.3.4/src/atest.c
ucpp-1.3.4/src/cpp.c
ucpp-1.3.4/src/cpp.h
ucpp-1.3.4/src/eval.c
ucpp-1.3.4/src/hash.c
ucpp-1.3.4/src/hash.h
ucpp-1.3.4/src/lexer.c
ucpp-1.3.4/src/macro.c
ucpp-1.3.4/src/mem.c
ucpp-1.3.4/src/mem.h
ucpp-1.3.4/src/nhash.c
ucpp-1.3.4/src/nhash.h
ucpp-1.3.4/src/sample.c
ucpp-1.3.4/src/tune.h
ucpp-1.3.4/src/ucpp-config.h
ucpp-1.3.4/src/ucppi.h

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: ucpp-1.3.4-3.fc21.i686.rpm
          ucpp-libs-1.3.4-3.fc21.i686.rpm
          ucpp-devel-1.3.4-3.fc21.i686.rpm
          ucpp-1.3.4-3.fc21.src.rpm
ucpp.i686: W: spelling-error Summary(en_US) Embeddable -> Embedded
ucpp.i686: W: spelling-error Summary(en_US) preprocessor -> processor, predecessor, process's
ucpp.i686: W: spelling-error %description -l en_US preprocessor -> processor, predecessor, process's
ucpp-libs.i686: W: spelling-error Summary(en_US) preprocessing -> reprocessing, p reprocessing, teleprocessing
ucpp-libs.i686: W: spelling-error %description -l en_US libucpp -> Cliburn
ucpp-libs.i686: W: spelling-error %description -l en_US preprocessing -> reprocessing, p reprocessing, teleprocessing
ucpp-devel.i686: W: spelling-error %description -l en_US preprocessing -> reprocessing, p reprocessing, teleprocessing
ucpp-devel.i686: W: no-documentation
ucpp.src: W: spelling-error Summary(en_US) Embeddable -> Embedded
ucpp.src: W: spelling-error Summary(en_US) preprocessor -> processor, predecessor, process's
ucpp.src: W: spelling-error %description -l en_US preprocessor -> processor, predecessor, process's
4 packages and 0 specfiles checked; 0 errors, 11 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ucpp ucpp-libs ucpp-devel
ucpp.i686: W: spelling-error Summary(en_US) Embeddable -> Embedded
ucpp.i686: W: spelling-error Summary(en_US) preprocessor -> processor, predecessor, process's
ucpp.i686: W: spelling-error %description -l en_US preprocessor -> processor, predecessor, process's
ucpp-libs.i686: W: spelling-error Summary(en_US) preprocessing -> reprocessing, p reprocessing, teleprocessing
ucpp-libs.i686: W: spelling-error %description -l en_US libucpp -> Cliburn
ucpp-libs.i686: W: spelling-error %description -l en_US preprocessing -> reprocessing, p reprocessing, teleprocessing
ucpp-devel.i686: W: spelling-error %description -l en_US preprocessing -> reprocessing, p reprocessing, teleprocessing
ucpp-devel.i686: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 8 warnings.
# echo 'rpmlint-done:'



Requires
--------
ucpp (rpmlib, GLIBC filtered):
    libc.so.6
    libucpp.so.13
    rtld(GNU_HASH)
    ucpp-libs(x86-32)

ucpp-libs (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6
    rtld(GNU_HASH)

ucpp-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libucpp.so.13
    ucpp-libs(x86-32)



Provides
--------
ucpp:
    ucpp
    ucpp(x86-32)

ucpp-libs:
    libucpp.so.13
    ucpp-libs
    ucpp-libs(x86-32)

ucpp-devel:
    pkgconfig(libucpp)
    ucpp-devel
    ucpp-devel(x86-32)



Source checksums
----------------
http://dev.gentooexperimental.org/~scarabeus/ucpp-1.3.4.tar.xz :
  CHECKSUM(SHA256) this package     : 6eab925e49f5635962a2152b15536b92d861b409b18337317c122ee065133d25
  CHECKSUM(SHA256) upstream package : 6eab925e49f5635962a2152b15536b92d861b409b18337317c122ee065133d25


AutoTools: Obsoleted m4s found
------------------------------
  AC_PROG_LIBTOOL found in: ucpp-1.3.4/configure.ac:31


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/bin/fedora-review -rvn ucpp-1.3.4-3.fc20.src.rpm
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


------------------------------
1. Ask upstream to use new m4 macros.

2. Koji http://koji.fedoraproject.org/koji/taskinfo?taskID=6561718

PACKAGE APPROVED.
Comment 10 Dominik 'Rathann' Mierzejewski 2014-02-24 08:40:33 EST
New Package SCM Request
=======================
Package Name: ucpp
Short Description: Embeddable, quick, light and fully compliant ISO C99 preprocessor
Owners: rathann
Branches: f19 f20 el6 epel7
InitialCC:
Comment 11 Dominik 'Rathann' Mierzejewski 2014-02-24 08:42:12 EST
Thanks for the review, Chris.
Comment 12 Gwyn Ciesla 2014-02-24 08:43:41 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2014-02-25 06:20:50 EST
ucpp-1.3.4-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ucpp-1.3.4-3.fc20
Comment 14 Fedora Update System 2014-02-25 06:21:01 EST
ucpp-1.3.4-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ucpp-1.3.4-3.fc19
Comment 15 Fedora Update System 2014-02-26 08:52:28 EST
Package ucpp-1.3.4-3.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing ucpp-1.3.4-3.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-3086/ucpp-1.3.4-3.fc20
then log in and leave karma (feedback).
Comment 16 Fedora Update System 2014-03-07 01:33:44 EST
ucpp-1.3.4-3.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2014-03-07 01:38:35 EST
ucpp-1.3.4-3.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.